import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:stateful_provider/provider/process_status_provider.dart';

class ProcessStatusWidget extends StatelessWidget {
  void Function(dynamic error, void Function() close) error;
  final Widget process;

  ProcessStatusWidget(this.error,
      {this.process = const CircularProgressIndicator()});

  @override
  Widget build(BuildContext context) => Consumer<ProcessStatusProvider>(
        builder: (_, provider, __) {
          if (provider.hasError) {
            final current = provider.currentError();
            WidgetsBinding.instance?.addPostFrameCallback((timeStamp) {
              error(current, () {
                provider.consumeError(current);
              });
            });
          }
          return provider.isProcessing ? process : Container();
        },
      );
}
